/************************************************************************************************************
**	FileName:	common_type.h
**	Description:	
**	Major Function:	
**
--------------------------------------------------------------------------------------------------------
**	Software:	
**	Hareware:	
**						
**	Company:	ngds
--------------------------------------------------------------------------------------------------------
**	Modified:
**	Author 			Date 			 Comment
________________________________________________________________________________________________________
**	Cesar.Li		2014-11-03		Original
**
**
************************************************************************************************************/


#ifndef	_COMMON_TYPE_H
#define	_COMMON_TYPE_H
#include "common_define.h"

#include "compiler_abstraction.h"
#include <stdint.h>
#include <stdbool.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

//#include "zkm_utils.h"

#ifdef __cplusplus
extern "C" {
#endif

#if defined(__C51__)

	#define PRAGMA_PACK_IGNORED
	#define WEAK_IGNORED

	#ifdef WEAK_IGNORED
		#undef	__WEAK
		#define	__WEAK	
	#endif


	

	#ifndef const_t	
	#define const_t  code
	#endif

	#ifndef _IDATA
	#define _IDATA  idata
	#endif

	#ifndef __INLINE
	#define __INLINE 
	#endif

	#ifndef int8d_t
	typedef char  data             int8d_t;
	#endif
	#ifndef int16d_t
	typedef short data             int16d_t;
	#endif
	#ifndef int32d_t
	typedef long  data             int32d_t;
	#endif
	#ifndef int8i_t
	typedef char  idata            int8i_t;
	#endif
	#ifndef int16i_t
	typedef short idata            int16i_t;
	#endif
	#ifndef int32i_t
	typedef long  idata            int32i_t;
	#endif
	#ifndef uint8d_t
	typedef unsigned char  data           	uint8d_t;
	#endif
	#ifndef uint16d_t
	typedef unsigned short data             uint16d_t;
	#endif
	#ifndef uint32d_t
	typedef unsigned long  data             uint32d_t;
	#endif
	#ifndef uint8i_t
	typedef unsigned char  idata            uint8i_t;
	#endif
	#ifndef uint16i_t
	typedef unsigned short idata            uint16i_t;
	#endif
	#ifndef uint32i_t
	typedef unsigned long  idata            uint32i_t;
	#endif
	#ifndef uint8c_t
	typedef const unsigned char  code            uint8c_t;
	#endif
	#ifndef uint16i_t
	typedef const unsigned short code            uint16c_t;
	#endif
	#ifndef uint32i_t
	typedef const unsigned long  code            uint32c_t;
	#endif

#else


	#ifndef _IDATA
	#define _IDATA
	#endif



	#ifndef const_t	
	#define const_t const
	#endif
	#ifndef int8d_t
	typedef char               int8d_t;
	#endif
	#ifndef int16d_t
	typedef short              int16d_t;
	#endif
	#ifndef int32d_t
	typedef long               int32d_t;
	#endif
	#ifndef int8i_t
	typedef char              int8i_t;
	#endif
	#ifndef int16i_t
	typedef short             int16i_t;
	#endif
	#ifndef int32i_t
	typedef long              int32i_t;
	#endif
	#ifndef uint8d_t
	typedef unsigned char               uint8d_t;
	#endif
	#ifndef uint16d_t
	typedef unsigned short              uint16d_t;
	#endif
	#ifndef uint32d_t
	typedef unsigned long               uint32d_t;
	#endif
	#ifndef uint8i_t
	typedef unsigned char              uint8i_t;
	#endif
	#ifndef uint16i_t
	typedef unsigned short             uint16i_t;
	#endif
	#ifndef uint32i_t
	typedef unsigned long              uint32i_t;
	#endif
	#ifndef uint8c_t
	typedef const unsigned char              uint8c_t;
	#endif
	#ifndef uint16i_t
	typedef const unsigned short             uint16c_t;
	#endif
	#ifndef uint32i_t
	typedef const unsigned long              uint32c_t;
	#endif

#endif

#ifdef __cplusplus
}
#endif

#endif

